using System;
using System.Runtime.InteropServices;

namespace AgileSoftwareInc.Tapi2Lib
{
	/// <summary>
	/// Media handling functions.
	/// </summary>
	public class CMedia
	{
		/*
			class CMedia
			Copyright  2005 by Agile Software Inc.
			All Rights Reserved.
      
			Created: Helen Warn
			Updated: July 13, 2005

		*/	

		private uint m_waveinDeviceID = 0;
		private uint m_waveoutDeviceID = 0;

		public enum WaveDirection
		{
			WaveIn = 1,
			WaveOut = 2,
			WaveInOut = 3
		}

		private const string WAVEIN = "wave/in";
		private const string WAVEOUT = "wave/out";
		private const string WAVEINOUT = "wave/in/out";

		public CMedia()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		public CTapi.LineErrReturn lineGetID(IntPtr hLine, IntPtr hCall, WaveDirection wavedir)
		{
			string deviceClass = string.Empty;	
			switch (wavedir)
			{
				case WaveDirection.WaveIn:
					deviceClass = WAVEIN;
					break;
				case WaveDirection.WaveOut:
					deviceClass = WAVEOUT;
					break;
				case WaveDirection.WaveInOut:
					deviceClass = WAVEINOUT;
					break;
			}

			CTapi.LineErrReturn ret;
			CTapi.varstring deviceID = new CTapi.varstring();
			deviceID.buffer = new byte[1024];
			deviceID.dwStringFormat = CTapi.StringFormat.STRINGFORMAT_BINARY;
			deviceID.dwTotalSize = (uint)Marshal.SizeOf(deviceID);

			ret = CTapi.lineGetID(hLine, 0, hCall, CTapi.LineCallSelect.LINECALLSELECT_CALL, ref deviceID, deviceClass);
			if (ret == CTapi.LineErrReturn.LINEERR_OK)
			{
				// in this case, we know we have enough space, so we don't have to check if the buffer is too small
				switch (wavedir)
				{
					case WaveDirection.WaveIn:
						this.m_waveinDeviceID = BitConverter.ToUInt32(deviceID.buffer, 0);
						break;
					case WaveDirection.WaveOut:
						this.m_waveoutDeviceID = BitConverter.ToUInt32(deviceID.buffer, 0);
						break;
					case WaveDirection.WaveInOut:
						this.m_waveinDeviceID = BitConverter.ToUInt32(deviceID.buffer, 0);
						this.m_waveoutDeviceID = BitConverter.ToUInt32(deviceID.buffer, 4);
						break;
				}
			}
			return ret;
		}

	}
} // namespace AgileSoftwareInc.Tapi2Lib
