using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Text;

namespace AgileSoftwareInc.TapiApp
{
  public class IncomingCall : INotifyPropertyChanged	
	{
		// from tapi
		private IntPtr m_hCall = IntPtr.Zero;
		private string m_callerID = string.Empty;
		private string m_callerName = string.Empty;
    private string m_company = string.Empty;
    private string m_customerClass = string.Empty;


		public IntPtr hCall
		{
			get { return m_hCall; }
		}


		public string CallerID
		{
			get { return m_callerID; }
			set
			{
        if ((value != this.m_callerID) && isValidCaller(value))
				{
					m_callerID = value;
					NotifyPropertyChanged("Caller ID");
				}
			}		
    }

		public string CallerName
		{
			get { return m_callerName; }
      set
			{
				if ((value != this.m_callerName) && isValidCaller(value))
				{
          m_callerName = value;
					NotifyPropertyChanged("Caller Name");
				}
			}		
		}

		public string Company
		{
			get {return m_company;}
			set
			{
        if (m_company != value)
        {
          m_company = value;
          NotifyPropertyChanged("Company");
        }
			}
		}

		public string CustomerClass
		{
			get {return m_customerClass;}
			set
			{
        if (m_customerClass != value)
        {
          m_customerClass = value;
          NotifyPropertyChanged("Class");
        }
      }
		}

		#region Constructors

		public IncomingCall(IntPtr hCall, string callerID, string callerName, string company, string companyClass)
		{
			m_hCall = hCall;
      if (isValidCaller(callerID))
          m_callerID = callerID;
      if (!isValidCaller(callerName))
        m_callerName = callerName;
			m_company = company;
      m_customerClass = companyClass;
		}

    public IncomingCall(IntPtr hCall, string callerID, string callerName)
      : this(hCall, callerID, callerName, "Company", "Class") { }

		#endregion Constructors

    #region Private Members

    private bool isValidCaller(string caller)
    {
      if (string.IsNullOrEmpty(caller))
        return false;
      if (caller.ToLower().Contains("private"))
        return false;
      if (caller.ToLower().Contains("unknown"))
        return false;
      return true;
    }

    #endregion Private Members

    #region INotifyPropertyChanged Members

    public event PropertyChangedEventHandler PropertyChanged;

    private void NotifyPropertyChanged(String info)
    {
      if (PropertyChanged != null)
      {
        PropertyChanged(this, new PropertyChangedEventArgs(info));
      }
    }


    #endregion
	}
}
